 /*
  * Khoros: $Id: vll2utm.h,v 1.1 1991/05/10 15:52:51 khoros Exp $
  */

 /*
  * $Log: vll2utm.h,v $
 * Revision 1.1  1991/05/10  15:52:51  khoros
 * Initial revision
 *
  */ 

/*
 *----------------------------------------------------------------------
 *
 * Copyright 1991, University of New Mexico.  All rights reserved.
 * Permission to copy and modify this software and its documen-
 * tation only for internal use in your organization is hereby
 * granted, provided that this notice is retained thereon and
 * on all copies.  UNM makes no representations as too the sui-
 * tability and operability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 * 
 * UNM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT-
 * NESS.  IN NO EVENT SHALL UNM BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY OTHER DAMAGES WHAT-
 * SOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PER-
 * FORMANCE OF THIS SOFTWARE.
 * 
 * No other rights, including for example, the right to redis-
 * tribute this software and its documentation or the right to
 * prepare derivative works, are granted unless specifically
 * provided in a separate license agreement.
 *---------------------------------------------------------------------
 */

#include "unmcopyright.h"        /* Copyright 1991 by UNM */


/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 >>>>
 >>>>         File Name: vll2utm.h
 >>>>            Author: Per Lysne
 >>>> Date Last Updated: Thu Mar  7 13:32:27 1991
 >>>> 
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/

#ifndef _vll2utm_h_
#define _vll2utm_h_

#include "vinclude.h"


/* -include_includes */
/* -include_includes_end */

char	**av,		/* argv and argc used by gparams */
	*program,	/* a pointer to the program name argv[0] */
	*calloc();
int	ac;

/****************************************************************
*
*                    vll2utm Argument Structure
*
****************************************************************/

typedef struct _vll2utm  {

/*
 *  input file (Required infile)
 */
char	*i_file;	/* input file FILENAME */
int	 i_flag;	/* input file FLAG */

/*
 *  output file (Required outfile)
 */
char	*o_file;	/* output file FILENAME */
int	 o_flag;	/* output file FLAG */

/*
 *  Locations in seconds or degrees (1=seconds) (Optional logical)
 */
int	 s_logic;	/* Locations in seconds or degrees (1=seconds) LOGIC */
int	 s_flag;  	/* Locations in seconds or degrees (1=seconds) FLAG */

}  vll2utm_struct;

vll2utm_struct *vll2utm;

/* -include_additions */
/* -include_additions_end */

/* -include_macros */
#define CHECKINPUT(program, img) {                                            \
        (void) proper_num_images (program, img, 1, TRUE);                     \
        (void) proper_loc_type   (program, img, VFF_LOC_EXPLICIT, TRUE);      \
}
/* -include_macros_end */

#endif
