 /*
  * Khoros: $Id: lconcert.c,v 1.1 1991/05/10 15:58:22 khoros Exp $
  */

#if !defined(lint) && !defined(SABER)
static char rcsid[] = "Khoros: $Id: lconcert.c,v 1.1 1991/05/10 15:58:22 khoros Exp $";
#endif

 /*
  * $Log: lconcert.c,v $
 * Revision 1.1  1991/05/10  15:58:22  khoros
 * Initial revision
 *
  */ 

/*
 *----------------------------------------------------------------------
 *
 * Copyright 1991, University of New Mexico.  All rights reserved.
 * Permission to copy and modify this software and its documen-
 * tation only for internal use in your organization is hereby
 * granted, provided that this notice is retained thereon and
 * on all copies.  UNM makes no representations as too the sui-
 * tability and operability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 * 
 * UNM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT-
 * NESS.  IN NO EVENT SHALL UNM BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY OTHER DAMAGES WHAT-
 * SOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PER-
 * FORMANCE OF THIS SOFTWARE.
 * 
 * No other rights, including for example, the right to redis-
 * tribute this software and its documentation or the right to
 * prepare derivative works, are granted unless specifically
 * provided in a separate license agreement.
 *---------------------------------------------------------------------
 */

#include "unmcopyright.h"        /* Copyright 1991 by UNM */

/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 >>>>
 >>>>         File Name: lconcert.c
 >>>>
 >>>>      Program Name: concert
 >>>>
 >>>> Date Last Updated: Tue Apr  2 15:04:01 1991 
 >>>>
 >>>>          Routines: lconcert - the library call for concert
 >>>>
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/


#include "xvinclude.h"


/* -library_includes */
#include "concert.h"
/* -library_includes_end */


/****************************************************************
*
* Routine Name: lconcert - library call for concert
*
* Purpose:
*
* Input:
* Output:
*
* Written By: Mark Young & Danielle Argiro
****************************************************************/


/* -library_def */
int lconcert(command, master, d2, d3, d4, d5, d6, d7, d8, d9, d10)

int     master;
char    *command, *d2, *d3, *d4, *d5, *d6, *d7, *d8, *d9, *d10;
/* -library_def_end */

/* -library_code */
{
        Display *display;


        display = xvf_initialize(ac, av, program);
        if (display == NULL)
        {
           fprintf(stderr, "Could not open connection to server");
           exit(0);
        }

        display_list = NULL;
        start_command(command, master, NULL);
        start_command(command, master, d2);
        if (d3)  start_command(command, master, d3);
        if (d4)  start_command(command, master, d4);
        if (d5)  start_command(command, master, d5);
        if (d6)  start_command(command, master, d6);
        if (d7)  start_command(command, master, d7);
        if (d8)  start_command(command, master, d8);
        if (d9)  start_command(command, master, d9);
        if (d10) start_command(command, master, d10);

        xvf_run_form();
        return(TRUE);
}
/* -library_code_end */
