 /*
  * Khoros: $Id: form_init.c,v 1.3 1992/03/20 22:38:54 dkhoros Exp $
  */

#if !defined(lint) && !defined(SABER)
static char rcsid[] = "Khoros: $Id: form_init.c,v 1.3 1992/03/20 22:38:54 dkhoros Exp $";
#endif

 /*
  * $Log: form_init.c,v $
 * Revision 1.3  1992/03/20  22:38:54  dkhoros
 * VirtualPatch5
 *
  */

/*
 *---------------------------------------------------------------------
 *            Copyright 1990 University of New Mexico
 * 
 * Permission to copy and modify this software and its documen- 
 * tation only for internal use in your organization is hereby 
 * granted, provided that this notice is retained thereon and 
 * on all copies.  UNM makes no representations as too the sui- 
 * tability and operability of this software for any purpose. 
 * It is provided 'as is' without express or implied warranty. 
 *  
 * UNM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, 
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT- 
 * NESS.  IN NO EVENT SHALL UNM BE LIABLE FOR ANY SPECIAL, 
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY OTHER DAMAGES WHAT- 
 * SOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER 
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS 
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PER- 
 * FORMANCE OF THIS SOFTWARE. 
 *  
 * No other rights, including for example, the right to redis- 
 * tribute this software and its documentation or the right to 
 * prepare derivative works, are granted unless specifically 
 * provided in a separate license agreement. 
 * 
 *---------------------------------------------------------------------
 */
#include "unmcopyright.h"
#include "xvforms.h"
#include "form_info.h"


/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 >>>>
 >>>>         File Name:  form_init.c
 >>>>
 >>>>      Program Desc:  code to initialize fields
 >>>>                      in the structure found in form_info.h
 >>>>
 >>>>            Author:  automatically generated by conductor
 >>>>
 >>>> Date Last Updated:  Fri Mar 13 14:22:54 1992
 >>>>
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/


_xvf_init_edit(formptr,forminfo)

xvf_form *formptr; 
edit *forminfo;
{
	int index;
	Line_Info line_info;
	char **database;

	xvf_clear_line_info(&line_info);
	database = formptr->db;

	/***** initializing 'edit' Form Information structure *****/

	forminfo->image_workspace_index = 2;
	forminfo->change_bands = false;
	forminfo->overlay_image = false;
	forminfo->combine_overlays = false;
	forminfo->info = false;
	forminfo->combine_annotations = false;
	forminfo->quit = false;
	forminfo->zoom_subform = (edit_zoom_subform *) 
			  malloc(sizeof(edit_zoom_subform));


	index = 32;

	xvf_parse_startsubform_line(database[index], &line_info);
	forminfo->zoom_subform_selected = line_info.selected;
	forminfo->zoom_subform_index = 32;
	forminfo->zoom_subform_sfb_index = 3;

	/*** initializing 'forminfo->zoom_subform'
	      Subform Information structure ***/

	forminfo->zoom_subform->zoom = (zoom_subform_zoom *) 
			  malloc(sizeof(zoom_subform_zoom));


	index = 33;

	xvf_parse_startpane_line(database[index], &line_info);
	forminfo->zoom_subform->zoom_selected = line_info.selected;
	forminfo->zoom_subform->zoom_index = 33;
	forminfo->zoom_subform->zoom_gb_index = 0;
	index++;


	/* initializing 'forminfo->zoom_subform->zoom'
	       Pane Information structure */

	xvf_parse_float_line(database[index], &line_info);
	forminfo->zoom_subform->zoom->zoomfactor = line_info.float_def;
	line_info.float_val = line_info.float_def;
	xvf_deparse_float_line(&line_info, database,index);
	forminfo->zoom_subform->zoom->zoomfactor_index = index;
forminfo->zoom_subform->zoom->zoomfactor_selected = false;
	index++;

	xvf_parse_cycle_line(database[index], &line_info);
	forminfo->zoom_subform->zoom->cursor = line_info.cycle_val;
	xvf_deparse_cycle_line(&line_info, database,index);
	forminfo->zoom_subform->zoom->cursor_index = index;
	forminfo->zoom_subform->zoom->cursor_selected = false;
	index++;

	xvf_parse_logic_line(database[index], &line_info);
	forminfo->zoom_subform->zoom->update_mode = line_info.logical_def;
	line_info.logical_val = line_info.logical_def;
	xvf_deparse_logic_line(&line_info, database,index);
	forminfo->zoom_subform->zoom->update_mode_index = index;
forminfo->zoom_subform->zoom->update_mode_selected = false;
	index++;

	forminfo->zoom_subform->zoom->zoom_workspace_index = 37;
	index++;

	index++;

	forminfo->zoom_subform->zoom->quit = false;
	index++;

	if (!(xvf_create_subform(formptr->db, formptr, formptr->subform->next_subform, true)))
	   return(false);
	_xvf_get_zoom(formptr, forminfo->zoom_subform->zoom);
	forminfo->pixels_subform = (edit_pixels_subform *) 
			  malloc(sizeof(edit_pixels_subform));


	index = 42;

	xvf_parse_startsubform_line(database[index], &line_info);
	forminfo->pixels_subform_selected = line_info.selected;
	forminfo->pixels_subform_index = 42;
	forminfo->pixels_subform_sfb_index = 4;

	/*** initializing 'forminfo->pixels_subform'
	      Subform Information structure ***/

	forminfo->pixels_subform->pixels = (pixels_subform_pixels *) 
			  malloc(sizeof(pixels_subform_pixels));


	index = 43;

	xvf_parse_startpane_line(database[index], &line_info);
	forminfo->pixels_subform->pixels_selected = line_info.selected;
	forminfo->pixels_subform->pixels_index = 43;
	forminfo->pixels_subform->pixels_gb_index = 0;
	index++;


	/* initializing 'forminfo->pixels_subform->pixels'
	       Pane Information structure */

	xvf_parse_toggle_line(database[index], &line_info);
	forminfo->pixels_subform->pixels->color_model_val = line_info.toggle_def;
	line_info.toggle_val = line_info.toggle_def;
	xvf_deparse_toggle_line(&line_info, database,index);
	forminfo->pixels_subform->pixels->color_model_index = index;
forminfo->pixels_subform->pixels->color_model_selected = false;
	index++;

	index = 54;
	xvf_parse_logic_line(database[index], &line_info);
	forminfo->pixels_subform->pixels->update_mode = line_info.logical_def;
	line_info.logical_val = line_info.logical_def;
	xvf_deparse_logic_line(&line_info, database,index);
	forminfo->pixels_subform->pixels->update_mode_index = index;
forminfo->pixels_subform->pixels->update_mode_selected = false;
	index++;

	forminfo->pixels_subform->pixels->pixels_workspace_index = 55;
	index++;

	index++;

	forminfo->pixels_subform->pixels->quit = false;
	index++;

	if (!(xvf_create_subform(formptr->db, formptr, formptr->subform->next_subform->next_subform, true)))
	   return(false);
	_xvf_get_pixels(formptr, forminfo->pixels_subform->pixels);
	forminfo->lut_subform = (edit_lut_subform *) 
			  malloc(sizeof(edit_lut_subform));


	index = 60;

	xvf_parse_startsubform_line(database[index], &line_info);
	forminfo->lut_subform_selected = line_info.selected;
	forminfo->lut_subform_index = 60;
	forminfo->lut_subform_sfb_index = 5;

	/*** initializing 'forminfo->lut_subform'
	      Subform Information structure ***/

	forminfo->lut_subform->lut = (lut_subform_lut *) 
			  malloc(sizeof(lut_subform_lut));


	index = 61;

	xvf_parse_startpane_line(database[index], &line_info);
	forminfo->lut_subform->lut_selected = line_info.selected;
	forminfo->lut_subform->lut_index = 61;
	forminfo->lut_subform->lut_gb_index = 0;
	index++;


	/* initializing 'forminfo->lut_subform->lut'
	       Pane Information structure */

	xvf_parse_toggle_line(database[index], &line_info);
	forminfo->lut_subform->lut->color_model_val = line_info.toggle_def;
	line_info.toggle_val = line_info.toggle_def;
	xvf_deparse_toggle_line(&line_info, database,index);
	forminfo->lut_subform->lut->color_model_index = index;
forminfo->lut_subform->lut->color_model_selected = false;
	index++;

	index = 72;
	xvf_parse_logic_line(database[index], &line_info);
	forminfo->lut_subform->lut->histogram = line_info.logical_def;
	line_info.logical_val = line_info.logical_def;
	xvf_deparse_logic_line(&line_info, database,index);
	forminfo->lut_subform->lut->histogram_index = index;
forminfo->lut_subform->lut->histogram_selected = false;
	index++;

	xvf_parse_cycle_line(database[index], &line_info);
	forminfo->lut_subform->lut->hist_type = line_info.cycle_val;
	xvf_deparse_cycle_line(&line_info, database,index);
	forminfo->lut_subform->lut->hist_type_index = index;
	forminfo->lut_subform->lut->hist_type_selected = false;
	index++;

	forminfo->lut_subform->lut->lut_workspace_index = 74;
	index++;

	index++;

	forminfo->lut_subform->lut->quit = false;
	index++;

	if (!(xvf_create_subform(formptr->db, formptr, formptr->subform->next_subform->next_subform->next_subform, true)))
	   return(false);
	_xvf_get_lut(formptr, forminfo->lut_subform->lut);
	forminfo->pseudo_subform = (edit_pseudo_subform *) 
			  malloc(sizeof(edit_pseudo_subform));


	index = 79;

	xvf_parse_startsubform_line(database[index], &line_info);
	forminfo->pseudo_subform_selected = line_info.selected;
	forminfo->pseudo_subform_index = 79;
	forminfo->pseudo_subform_sfb_index = 6;

	/*** initializing 'forminfo->pseudo_subform'
	      Subform Information structure ***/

	forminfo->pseudo_subform->pseudo = (pseudo_subform_pseudo *) 
			  malloc(sizeof(pseudo_subform_pseudo));


	index = 80;

	xvf_parse_startpane_line(database[index], &line_info);
	forminfo->pseudo_subform->pseudo_selected = line_info.selected;
	forminfo->pseudo_subform->pseudo_index = 80;
	forminfo->pseudo_subform->pseudo_gb_index = 0;
	index++;


	/* initializing 'forminfo->pseudo_subform->pseudo'
	       Pane Information structure */

	xvf_parse_toggle_line(database[index], &line_info);
	forminfo->pseudo_subform->pseudo->color_model_val = line_info.toggle_def;
	line_info.toggle_val = line_info.toggle_def;
	xvf_deparse_toggle_line(&line_info, database,index);
	forminfo->pseudo_subform->pseudo->color_model_index = index;
forminfo->pseudo_subform->pseudo->color_model_selected = false;
	index++;

	index = 91;
	forminfo->pseudo_subform->pseudo->pseudo_workspace_index = 91;
	index++;

	index++;

	forminfo->pseudo_subform->pseudo->quit = false;
	index++;

	if (!(xvf_create_subform(formptr->db, formptr, formptr->subform->next_subform->next_subform->next_subform->next_subform, true)))
	   return(false);
	_xvf_get_pseudo(formptr, forminfo->pseudo_subform->pseudo);
	forminfo->thres_subform = (edit_thres_subform *) 
			  malloc(sizeof(edit_thres_subform));


	index = 96;

	xvf_parse_startsubform_line(database[index], &line_info);
	forminfo->thres_subform_selected = line_info.selected;
	forminfo->thres_subform_index = 96;
	forminfo->thres_subform_sfb_index = 7;

	/*** initializing 'forminfo->thres_subform'
	      Subform Information structure ***/

	forminfo->thres_subform->thres = (thres_subform_thres *) 
			  malloc(sizeof(thres_subform_thres));


	index = 97;

	xvf_parse_startpane_line(database[index], &line_info);
	forminfo->thres_subform->thres_selected = line_info.selected;
	forminfo->thres_subform->thres_index = 97;
	forminfo->thres_subform->thres_gb_index = 0;
	index++;


	/* initializing 'forminfo->thres_subform->thres'
	       Pane Information structure */

	xvf_parse_logic_line(database[index], &line_info);
	forminfo->thres_subform->thres->invert = line_info.logical_def;
	line_info.logical_val = line_info.logical_def;
	xvf_deparse_logic_line(&line_info, database,index);
	forminfo->thres_subform->thres->invert_index = index;
forminfo->thres_subform->thres->invert_selected = false;
	index++;

	xvf_parse_int_line(database[index], &line_info);
	forminfo->thres_subform->thres->non_zero_pixel = line_info.int_def;
	line_info.int_val = line_info.int_def;
	xvf_deparse_int_line(&line_info, database,index);
	forminfo->thres_subform->thres->non_zero_pixel_index = index;
forminfo->thres_subform->thres->non_zero_pixel_selected = false;
	index++;

	xvf_parse_toggle_line(database[index], &line_info);
	forminfo->thres_subform->thres->thresholding_val = line_info.toggle_def;
	line_info.toggle_val = line_info.toggle_def;
	xvf_deparse_toggle_line(&line_info, database,index);
	forminfo->thres_subform->thres->thresholding_index = index;
forminfo->thres_subform->thres->thresholding_selected = false;
	index++;

	index = 104;
	forminfo->thres_subform->thres->thres_workspace_index = 104;
	index++;

	xvf_parse_logic_line(database[index], &line_info);
	forminfo->thres_subform->thres->accept = line_info.logical_def;
	line_info.logical_val = line_info.logical_def;
	xvf_deparse_logic_line(&line_info, database,index);
	forminfo->thres_subform->thres->accept_index = index;
forminfo->thres_subform->thres->accept_selected = false;
	index++;

	xvf_parse_int_line(database[index], &line_info);
	forminfo->thres_subform->thres->fill_pixel = line_info.int_def;
	line_info.int_val = line_info.int_def;
	xvf_deparse_int_line(&line_info, database,index);
	forminfo->thres_subform->thres->fill_pixel_index = index;
forminfo->thres_subform->thres->fill_pixel_selected = false;
	index++;

	index++;

	forminfo->thres_subform->thres->quit = false;
	index++;

	if (!(xvf_create_subform(formptr->db, formptr, formptr->subform->next_subform->next_subform->next_subform->next_subform->next_subform, true)))
	   return(false);
	_xvf_get_thres(formptr, forminfo->thres_subform->thres);
	forminfo->files_subform = (edit_files_subform *) 
			  malloc(sizeof(edit_files_subform));


	index = 111;

	xvf_parse_startsubform_line(database[index], &line_info);
	forminfo->files_subform_selected = line_info.selected;
	forminfo->files_subform_index = 111;
	forminfo->files_subform_sfb_index = 8;

	/*** initializing 'forminfo->files_subform'
	      Subform Information structure ***/

	forminfo->files_subform->file = (files_subform_file *) 
			  malloc(sizeof(files_subform_file));


	index = 112;

	xvf_parse_startpane_line(database[index], &line_info);
	forminfo->files_subform->file_selected = line_info.selected;
	forminfo->files_subform->file_index = 112;
	forminfo->files_subform->file_gb_index = 0;
	index++;


	/* initializing 'forminfo->files_subform->file'
	       Pane Information structure */

	index++;

	xvf_parse_string_line(database[index], &line_info);
	if (line_info.string_def != NULL) {
	   forminfo->files_subform->file->input_path = 
		xvf_strcpy(line_info.string_def);
	}
	else  forminfo->files_subform->file->input_path = NULL;

	xvf_deparse_string_line(&line_info, database,index);
	forminfo->files_subform->file->input_path_index = index;
forminfo->files_subform->file->input_path_selected = false;
	index++;

	xvf_parse_string_line(database[index], &line_info);
	if (line_info.string_def != NULL) {
	   forminfo->files_subform->file->output_path = 
		xvf_strcpy(line_info.string_def);
	}
	else  forminfo->files_subform->file->output_path = NULL;

	xvf_deparse_string_line(&line_info, database,index);
	forminfo->files_subform->file->output_path_index = index;
forminfo->files_subform->file->output_path_selected = false;
	index++;

	index++;

	xvf_parse_input_line(database[index], &line_info);
	if (line_info.file_def != NULL) {
	   forminfo->files_subform->file->image = 
		xvf_strcpy(line_info.file_def);
	}
	else  forminfo->files_subform->file->image = NULL;

	xvf_deparse_input_line(&line_info, database, index);
	forminfo->files_subform->file->image_index = index;
forminfo->files_subform->file->image_selected = false;
	index++;

	index++;

	xvf_parse_input_line(database[index], &line_info);
	if (line_info.file_def != NULL) {
	   forminfo->files_subform->file->colormap = 
		xvf_strcpy(line_info.file_def);
	}
	else  forminfo->files_subform->file->colormap = NULL;

	xvf_deparse_input_line(&line_info, database, index);
	forminfo->files_subform->file->colormap_index = index;
forminfo->files_subform->file->colormap_selected = false;
	index++;

	index++;

	xvf_parse_input_line(database[index], &line_info);
	if (line_info.file_def != NULL) {
	   forminfo->files_subform->file->clip = 
		xvf_strcpy(line_info.file_def);
	}
	else  forminfo->files_subform->file->clip = NULL;

	xvf_deparse_input_line(&line_info, database, index);
	forminfo->files_subform->file->clip_index = index;
forminfo->files_subform->file->clip_selected = false;
	index++;

	index++;

	xvf_parse_input_line(database[index], &line_info);
	if (line_info.file_def != NULL) {
	   forminfo->files_subform->file->shape = 
		xvf_strcpy(line_info.file_def);
	}
	else  forminfo->files_subform->file->shape = NULL;

	xvf_deparse_input_line(&line_info, database, index);
	forminfo->files_subform->file->shape_index = index;
forminfo->files_subform->file->shape_selected = false;
	index++;

	index++;

	xvf_parse_input_line(database[index], &line_info);
	if (line_info.file_def != NULL) {
	   forminfo->files_subform->file->overlay = 
		xvf_strcpy(line_info.file_def);
	}
	else  forminfo->files_subform->file->overlay = NULL;

	xvf_deparse_input_line(&line_info, database, index);
	forminfo->files_subform->file->overlay_index = index;
forminfo->files_subform->file->overlay_selected = false;
	index++;

	index++;

	xvf_parse_output_line(database[index], &line_info);
	if (line_info.file_def != NULL) {
	   forminfo->files_subform->file->outfile = 
		xvf_strcpy(line_info.file_def);
	}
	else  forminfo->files_subform->file->outfile = NULL;

	xvf_deparse_output_line(&line_info, database,index);
	forminfo->files_subform->file->outfile_index = index;
forminfo->files_subform->file->outfile_selected = false;
	index++;

	index++;

	xvf_parse_output_line(database[index], &line_info);
	if (line_info.file_def != NULL) {
	   forminfo->files_subform->file->outmap = 
		xvf_strcpy(line_info.file_def);
	}
	else  forminfo->files_subform->file->outmap = NULL;

	xvf_deparse_output_line(&line_info, database,index);
	forminfo->files_subform->file->outmap_index = index;
forminfo->files_subform->file->outmap_selected = false;
	index++;

	index++;

	forminfo->files_subform->file->quit = false;
	index++;

	forminfo->roi_subform = (edit_roi_subform *) 
			  malloc(sizeof(edit_roi_subform));


	index = 134;

	xvf_parse_startsubform_line(database[index], &line_info);
	forminfo->roi_subform_selected = line_info.selected;
	forminfo->roi_subform_index = 134;
	forminfo->roi_subform_sfb_index = 16;

	/*** initializing 'forminfo->roi_subform'
	      Subform Information structure ***/

	forminfo->roi_subform->roi = (roi_subform_roi *) 
			  malloc(sizeof(roi_subform_roi));


	index = 135;

	xvf_parse_startpane_line(database[index], &line_info);
	forminfo->roi_subform->roi_selected = line_info.selected;
	forminfo->roi_subform->roi_index = 135;
	forminfo->roi_subform->roi_gb_index = 0;
	index++;


	/* initializing 'forminfo->roi_subform->roi'
	       Pane Information structure */

	xvf_parse_logic_line(database[index], &line_info);
	forminfo->roi_subform->roi->place_val = line_info.logical_def;
	line_info.logical_val = line_info.logical_def;
	xvf_deparse_logic_line(&line_info, database,index);
	forminfo->roi_subform->roi->place_val_index = index;
forminfo->roi_subform->roi->place_val_selected = false;
	index++;

	index++;

	xvf_parse_int_line(database[index], &line_info);
	forminfo->roi_subform->roi->x = line_info.int_def;
	line_info.int_val = line_info.int_def;
	xvf_deparse_int_line(&line_info, database,index);
	forminfo->roi_subform->roi->x_index = index;
	index++;

	xvf_parse_int_line(database[index], &line_info);
	forminfo->roi_subform->roi->y = line_info.int_def;
	line_info.int_val = line_info.int_def;
	xvf_deparse_int_line(&line_info, database,index);
	forminfo->roi_subform->roi->y_index = index;
	index++;

	xvf_parse_int_line(database[index], &line_info);
	forminfo->roi_subform->roi->width = line_info.int_def;
	line_info.int_val = line_info.int_def;
	xvf_deparse_int_line(&line_info, database,index);
	forminfo->roi_subform->roi->width_index = index;
	index++;

	xvf_parse_int_line(database[index], &line_info);
	forminfo->roi_subform->roi->height = line_info.int_def;
	line_info.int_val = line_info.int_def;
	xvf_deparse_int_line(&line_info, database,index);
	forminfo->roi_subform->roi->height_index = index;
	index++;

	index++;

	xvf_parse_input_line(database[index], &line_info);
	if (line_info.file_def != NULL) {
	   forminfo->roi_subform->roi->insert = 
		xvf_strcpy(line_info.file_def);
	}
	else  forminfo->roi_subform->roi->insert = NULL;

	xvf_deparse_input_line(&line_info, database, index);
	forminfo->roi_subform->roi->insert_index = index;
forminfo->roi_subform->roi->insert_selected = false;
	index++;

	index++;

	xvf_parse_output_line(database[index], &line_info);
	if (line_info.file_def != NULL) {
	   forminfo->roi_subform->roi->extract = 
		xvf_strcpy(line_info.file_def);
	}
	else  forminfo->roi_subform->roi->extract = NULL;

	xvf_deparse_output_line(&line_info, database,index);
	forminfo->roi_subform->roi->extract_index = index;
forminfo->roi_subform->roi->extract_selected = false;
	index++;

	index++;

	xvf_parse_logic_line(database[index], &line_info);
	forminfo->roi_subform->roi->options = line_info.logical_def;
	line_info.logical_val = line_info.logical_def;
	xvf_deparse_logic_line(&line_info, database,index);
	forminfo->roi_subform->roi->options_index = index;
forminfo->roi_subform->roi->options_selected = false;
	index++;

	index++;

	forminfo->roi_subform->roi->commands = false;
	forminfo->roi_subform->roi->commands_index = index;
	index++;

	index++;

	forminfo->roi_subform->roi->quit = false;
	index++;

	forminfo->colormap_subform = (edit_colormap_subform *) 
			  malloc(sizeof(edit_colormap_subform));


	index = 154;

	xvf_parse_startsubform_line(database[index], &line_info);
	forminfo->colormap_subform_selected = line_info.selected;
	forminfo->colormap_subform_index = 154;
	forminfo->colormap_subform_sfb_index = 17;

	/*** initializing 'forminfo->colormap_subform'
	      Subform Information structure ***/

	forminfo->colormap_subform->colormap = (colormap_subform_colormap *) 
			  malloc(sizeof(colormap_subform_colormap));


	index = 155;

	xvf_parse_startpane_line(database[index], &line_info);
	forminfo->colormap_subform->colormap_selected = line_info.selected;
	forminfo->colormap_subform->colormap_index = 155;
	forminfo->colormap_subform->colormap_gb_index = 0;
	index++;


	/* initializing 'forminfo->colormap_subform->colormap'
	       Pane Information structure */

	index++;

	xvf_parse_toggle_line(database[index], &line_info);
	forminfo->colormap_subform->colormap->color_type_val = line_info.toggle_def;
	line_info.toggle_val = line_info.toggle_def;
	xvf_deparse_toggle_line(&line_info, database,index);
	forminfo->colormap_subform->colormap->color_type_index = index;
forminfo->colormap_subform->colormap->color_type_selected = false;
	index++;

	index = 175;
	index++;

	forminfo->colormap_subform->colormap->quit = false;
	index++;

	forminfo->xvoverlay = (edit_xvoverlay *) 
			  malloc(sizeof(edit_xvoverlay));


	index = 179;

	xvf_parse_startsubform_line(database[index], &line_info);
	forminfo->xvoverlay_selected = line_info.selected;
	forminfo->xvoverlay_index = 179;
	forminfo->xvoverlay_sfb_index = 18;

	/*** initializing 'forminfo->xvoverlay'
	      Subform Information structure ***/

	forminfo->xvoverlay->delete = false;
	forminfo->xvoverlay->copy = false;
	forminfo->xvoverlay->raise = false;
	forminfo->xvoverlay->lower = false;
	forminfo->xvoverlay->quit = false;
	forminfo->xvoverlay->ovfile = (xvoverlay_ovfile *) 
			  malloc(sizeof(xvoverlay_ovfile));


	index = 194;

	xvf_parse_startpane_line(database[index], &line_info);
	forminfo->xvoverlay->ovfile_selected = line_info.selected;
	forminfo->xvoverlay->ovfile_index = 194;
	forminfo->xvoverlay->ovfile_gb_index = 185;
	index++;


	/* initializing 'forminfo->xvoverlay->ovfile'
	       Pane Information structure */

	index++;

	xvf_parse_input_line(database[index], &line_info);
	if (line_info.file_def != NULL) {
	   forminfo->xvoverlay->ovfile->ov_input = 
		xvf_strcpy(line_info.file_def);
	}
	else  forminfo->xvoverlay->ovfile->ov_input = NULL;

	xvf_deparse_input_line(&line_info, database, index);
	forminfo->xvoverlay->ovfile->ov_input_index = index;
forminfo->xvoverlay->ovfile->ov_input_selected = false;
	index++;

	index++;

	xvf_parse_output_line(database[index], &line_info);
	if (line_info.file_def != NULL) {
	   forminfo->xvoverlay->ovfile->ov_output = 
		xvf_strcpy(line_info.file_def);
	}
	else  forminfo->xvoverlay->ovfile->ov_output = NULL;

	xvf_deparse_output_line(&line_info, database,index);
	forminfo->xvoverlay->ovfile->ov_output_index = index;
forminfo->xvoverlay->ovfile->ov_output_selected = false;
	index++;

	index++;

	forminfo->xvoverlay->text = (xvoverlay_text *) 
			  malloc(sizeof(xvoverlay_text));


	index = 201;

	xvf_parse_startpane_line(database[index], &line_info);
	forminfo->xvoverlay->text_selected = line_info.selected;
	forminfo->xvoverlay->text_index = 201;
	forminfo->xvoverlay->text_gb_index = 186;
	index++;


	/* initializing 'forminfo->xvoverlay->text'
	       Pane Information structure */

	xvf_parse_string_line(database[index], &line_info);
	if (line_info.string_def != NULL) {
	   forminfo->xvoverlay->text->color = 
		xvf_strcpy(line_info.string_def);
	}
	else  forminfo->xvoverlay->text->color = NULL;

	xvf_deparse_string_line(&line_info, database,index);
	forminfo->xvoverlay->text->color_index = index;
	index++;

	xvf_parse_string_line(database[index], &line_info);
	if (line_info.string_def != NULL) {
	   forminfo->xvoverlay->text->font = 
		xvf_strcpy(line_info.string_def);
	}
	else  forminfo->xvoverlay->text->font = NULL;

	xvf_deparse_string_line(&line_info, database,index);
	forminfo->xvoverlay->text->font_index = index;
	index++;

	xvf_parse_string_line(database[index], &line_info);
	if (line_info.string_def != NULL) {
	   forminfo->xvoverlay->text->text = 
		xvf_strcpy(line_info.string_def);
	}
	else  forminfo->xvoverlay->text->text = NULL;

	xvf_deparse_string_line(&line_info, database,index);
	forminfo->xvoverlay->text->text_index = index;
	index++;

	xvf_parse_toggle_line(database[index], &line_info);
	forminfo->xvoverlay->text->place_val = line_info.toggle_def;
	line_info.toggle_val = line_info.toggle_def;
	xvf_deparse_toggle_line(&line_info, database,index);
	forminfo->xvoverlay->text->place_index = index;
	index++;

	index = 209;
	xvf_parse_int_line(database[index], &line_info);
	forminfo->xvoverlay->text->x = line_info.int_def;
	line_info.int_val = line_info.int_def;
	xvf_deparse_int_line(&line_info, database,index);
	forminfo->xvoverlay->text->x_index = index;
	index++;

	xvf_parse_int_line(database[index], &line_info);
	forminfo->xvoverlay->text->y = line_info.int_def;
	line_info.int_val = line_info.int_def;
	xvf_deparse_int_line(&line_info, database,index);
	forminfo->xvoverlay->text->y_index = index;
	index++;

	forminfo->xvoverlay->text->create = false;
	forminfo->xvoverlay->text->create_index = index;
	index++;

	index++;

	forminfo->xvoverlay->circle = (xvoverlay_circle *) 
			  malloc(sizeof(xvoverlay_circle));


	index = 214;

	xvf_parse_startpane_line(database[index], &line_info);
	forminfo->xvoverlay->circle_selected = line_info.selected;
	forminfo->xvoverlay->circle_index = 214;
	forminfo->xvoverlay->circle_gb_index = 187;
	index++;


	/* initializing 'forminfo->xvoverlay->circle'
	       Pane Information structure */

	xvf_parse_string_line(database[index], &line_info);
	if (line_info.string_def != NULL) {
	   forminfo->xvoverlay->circle->color = 
		xvf_strcpy(line_info.string_def);
	}
	else  forminfo->xvoverlay->circle->color = NULL;

	xvf_deparse_string_line(&line_info, database,index);
	forminfo->xvoverlay->circle->color_index = index;
	index++;

	xvf_parse_int_line(database[index], &line_info);
	forminfo->xvoverlay->circle->width = line_info.int_def;
	line_info.int_val = line_info.int_def;
	xvf_deparse_int_line(&line_info, database,index);
	forminfo->xvoverlay->circle->width_index = index;
	index++;

	xvf_parse_logic_line(database[index], &line_info);
	forminfo->xvoverlay->circle->filled = line_info.logical_def;
	line_info.logical_val = line_info.logical_def;
	xvf_deparse_logic_line(&line_info, database,index);
	forminfo->xvoverlay->circle->filled_index = index;
	index++;

	xvf_parse_toggle_line(database[index], &line_info);
	forminfo->xvoverlay->circle->place_val = line_info.toggle_def;
	line_info.toggle_val = line_info.toggle_def;
	xvf_deparse_toggle_line(&line_info, database,index);
	forminfo->xvoverlay->circle->place_index = index;
	index++;

	index = 222;
	xvf_parse_int_line(database[index], &line_info);
	forminfo->xvoverlay->circle->x = line_info.int_def;
	line_info.int_val = line_info.int_def;
	xvf_deparse_int_line(&line_info, database,index);
	forminfo->xvoverlay->circle->x_index = index;
	index++;

	xvf_parse_int_line(database[index], &line_info);
	forminfo->xvoverlay->circle->y = line_info.int_def;
	line_info.int_val = line_info.int_def;
	xvf_deparse_int_line(&line_info, database,index);
	forminfo->xvoverlay->circle->y_index = index;
	index++;

	xvf_parse_int_line(database[index], &line_info);
	forminfo->xvoverlay->circle->x_edge = line_info.int_def;
	line_info.int_val = line_info.int_def;
	xvf_deparse_int_line(&line_info, database,index);
	forminfo->xvoverlay->circle->x_edge_index = index;
	index++;

	xvf_parse_int_line(database[index], &line_info);
	forminfo->xvoverlay->circle->y_edge = line_info.int_def;
	line_info.int_val = line_info.int_def;
	xvf_deparse_int_line(&line_info, database,index);
	forminfo->xvoverlay->circle->y_edge_index = index;
	index++;

	forminfo->xvoverlay->circle->create = false;
	forminfo->xvoverlay->circle->create_index = index;
	index++;

	index++;

	forminfo->xvoverlay->rectangle = (xvoverlay_rectangle *) 
			  malloc(sizeof(xvoverlay_rectangle));


	index = 229;

	xvf_parse_startpane_line(database[index], &line_info);
	forminfo->xvoverlay->rectangle_selected = line_info.selected;
	forminfo->xvoverlay->rectangle_index = 229;
	forminfo->xvoverlay->rectangle_gb_index = 188;
	index++;


	/* initializing 'forminfo->xvoverlay->rectangle'
	       Pane Information structure */

	xvf_parse_string_line(database[index], &line_info);
	if (line_info.string_def != NULL) {
	   forminfo->xvoverlay->rectangle->color = 
		xvf_strcpy(line_info.string_def);
	}
	else  forminfo->xvoverlay->rectangle->color = NULL;

	xvf_deparse_string_line(&line_info, database,index);
	forminfo->xvoverlay->rectangle->color_index = index;
	index++;

	xvf_parse_int_line(database[index], &line_info);
	forminfo->xvoverlay->rectangle->width = line_info.int_def;
	line_info.int_val = line_info.int_def;
	xvf_deparse_int_line(&line_info, database,index);
	forminfo->xvoverlay->rectangle->width_index = index;
	index++;

	xvf_parse_logic_line(database[index], &line_info);
	forminfo->xvoverlay->rectangle->filled = line_info.logical_def;
	line_info.logical_val = line_info.logical_def;
	xvf_deparse_logic_line(&line_info, database,index);
	forminfo->xvoverlay->rectangle->filled_index = index;
	index++;

	xvf_parse_toggle_line(database[index], &line_info);
	forminfo->xvoverlay->rectangle->place_val = line_info.toggle_def;
	line_info.toggle_val = line_info.toggle_def;
	xvf_deparse_toggle_line(&line_info, database,index);
	forminfo->xvoverlay->rectangle->place_index = index;
	index++;

	index = 237;
	xvf_parse_int_line(database[index], &line_info);
	forminfo->xvoverlay->rectangle->x = line_info.int_def;
	line_info.int_val = line_info.int_def;
	xvf_deparse_int_line(&line_info, database,index);
	forminfo->xvoverlay->rectangle->x_index = index;
	index++;

	xvf_parse_int_line(database[index], &line_info);
	forminfo->xvoverlay->rectangle->y = line_info.int_def;
	line_info.int_val = line_info.int_def;
	xvf_deparse_int_line(&line_info, database,index);
	forminfo->xvoverlay->rectangle->y_index = index;
	index++;

	xvf_parse_int_line(database[index], &line_info);
	forminfo->xvoverlay->rectangle->x_corner = line_info.int_def;
	line_info.int_val = line_info.int_def;
	xvf_deparse_int_line(&line_info, database,index);
	forminfo->xvoverlay->rectangle->x_corner_index = index;
	index++;

	xvf_parse_int_line(database[index], &line_info);
	forminfo->xvoverlay->rectangle->y_corner = line_info.int_def;
	line_info.int_val = line_info.int_def;
	xvf_deparse_int_line(&line_info, database,index);
	forminfo->xvoverlay->rectangle->y_corner_index = index;
	index++;

	forminfo->xvoverlay->rectangle->create = false;
	forminfo->xvoverlay->rectangle->create_index = index;
	index++;

	index++;

	forminfo->xvoverlay->line = (xvoverlay_line *) 
			  malloc(sizeof(xvoverlay_line));


	index = 244;

	xvf_parse_startpane_line(database[index], &line_info);
	forminfo->xvoverlay->line_selected = line_info.selected;
	forminfo->xvoverlay->line_index = 244;
	forminfo->xvoverlay->line_gb_index = 189;
	index++;


	/* initializing 'forminfo->xvoverlay->line'
	       Pane Information structure */

	xvf_parse_string_line(database[index], &line_info);
	if (line_info.string_def != NULL) {
	   forminfo->xvoverlay->line->color = 
		xvf_strcpy(line_info.string_def);
	}
	else  forminfo->xvoverlay->line->color = NULL;

	xvf_deparse_string_line(&line_info, database,index);
	forminfo->xvoverlay->line->color_index = index;
	index++;

	xvf_parse_int_line(database[index], &line_info);
	forminfo->xvoverlay->line->width = line_info.int_def;
	line_info.int_val = line_info.int_def;
	xvf_deparse_int_line(&line_info, database,index);
	forminfo->xvoverlay->line->width_index = index;
	index++;

	xvf_parse_toggle_line(database[index], &line_info);
	forminfo->xvoverlay->line->place_val = line_info.toggle_def;
	line_info.toggle_val = line_info.toggle_def;
	xvf_deparse_toggle_line(&line_info, database,index);
	forminfo->xvoverlay->line->place_index = index;
	index++;

	index = 251;
	xvf_parse_int_line(database[index], &line_info);
	forminfo->xvoverlay->line->x = line_info.int_def;
	line_info.int_val = line_info.int_def;
	xvf_deparse_int_line(&line_info, database,index);
	forminfo->xvoverlay->line->x_index = index;
	index++;

	xvf_parse_int_line(database[index], &line_info);
	forminfo->xvoverlay->line->y = line_info.int_def;
	line_info.int_val = line_info.int_def;
	xvf_deparse_int_line(&line_info, database,index);
	forminfo->xvoverlay->line->y_index = index;
	index++;

	xvf_parse_int_line(database[index], &line_info);
	forminfo->xvoverlay->line->x_end = line_info.int_def;
	line_info.int_val = line_info.int_def;
	xvf_deparse_int_line(&line_info, database,index);
	forminfo->xvoverlay->line->x_end_index = index;
	index++;

	xvf_parse_int_line(database[index], &line_info);
	forminfo->xvoverlay->line->y_end = line_info.int_def;
	line_info.int_val = line_info.int_def;
	xvf_deparse_int_line(&line_info, database,index);
	forminfo->xvoverlay->line->y_end_index = index;
	index++;

	forminfo->xvoverlay->line->create = false;
	forminfo->xvoverlay->line->create_index = index;
	index++;

	index++;

	forminfo->xvoverlay->polygon = (xvoverlay_polygon *) 
			  malloc(sizeof(xvoverlay_polygon));


	index = 258;

	xvf_parse_startpane_line(database[index], &line_info);
	forminfo->xvoverlay->polygon_selected = line_info.selected;
	forminfo->xvoverlay->polygon_index = 258;
	forminfo->xvoverlay->polygon_gb_index = 190;
	index++;


	/* initializing 'forminfo->xvoverlay->polygon'
	       Pane Information structure */

	xvf_parse_string_line(database[index], &line_info);
	if (line_info.string_def != NULL) {
	   forminfo->xvoverlay->polygon->color = 
		xvf_strcpy(line_info.string_def);
	}
	else  forminfo->xvoverlay->polygon->color = NULL;

	xvf_deparse_string_line(&line_info, database,index);
	forminfo->xvoverlay->polygon->color_index = index;
	index++;

	xvf_parse_int_line(database[index], &line_info);
	forminfo->xvoverlay->polygon->width = line_info.int_def;
	line_info.int_val = line_info.int_def;
	xvf_deparse_int_line(&line_info, database,index);
	forminfo->xvoverlay->polygon->width_index = index;
	index++;

	xvf_parse_logic_line(database[index], &line_info);
	forminfo->xvoverlay->polygon->filled = line_info.logical_def;
	line_info.logical_val = line_info.logical_def;
	xvf_deparse_logic_line(&line_info, database,index);
	forminfo->xvoverlay->polygon->filled_index = index;
	index++;

	forminfo->xvoverlay->polygon->create = false;
	forminfo->xvoverlay->polygon->create_index = index;
	index++;

	index++;

	forminfo->comment_subform = (edit_comment_subform *) 
			  malloc(sizeof(edit_comment_subform));


	index = 266;

	xvf_parse_startsubform_line(database[index], &line_info);
	forminfo->comment_subform_selected = line_info.selected;
	forminfo->comment_subform_index = 266;
	forminfo->comment_subform_sfb_index = 19;

	/*** initializing 'forminfo->comment_subform'
	      Subform Information structure ***/

	forminfo->comment_subform->comment = (comment_subform_comment *) 
			  malloc(sizeof(comment_subform_comment));


	index = 267;

	xvf_parse_startpane_line(database[index], &line_info);
	forminfo->comment_subform->comment_selected = line_info.selected;
	forminfo->comment_subform->comment_index = 267;
	forminfo->comment_subform->comment_gb_index = 0;
	index++;


	/* initializing 'forminfo->comment_subform->comment'
	       Pane Information structure */

	index++;

	xvf_parse_string_line(database[index], &line_info);
	if (line_info.string_def != NULL) {
	   forminfo->comment_subform->comment->comment_string = 
		xvf_strcpy(line_info.string_def);
	}
	else  forminfo->comment_subform->comment->comment_string = NULL;

	xvf_deparse_string_line(&line_info, database,index);
	forminfo->comment_subform->comment->comment_string_index = index;
	index++;

	forminfo->comment_subform->comment->comment = false;
	forminfo->comment_subform->comment->comment_index = index;
	index++;

	index++;

	forminfo->comment_subform->comment->quit = false;
	index++;

	_xvf_get_edit(formptr, forminfo);
	return(true);

}

