 /*
  * Khoros: $Id: reader.h,v 1.1 1991/05/10 15:59:00 khoros Exp $
  */

 /*
  * $Log: reader.h,v $
 * Revision 1.1  1991/05/10  15:59:00  khoros
 * Initial revision
 *
  */ 

/*
 *----------------------------------------------------------------------
 *
 * Copyright 1991, University of New Mexico.  All rights reserved.
 * Permission to copy and modify this software and its documen-
 * tation only for internal use in your organization is hereby
 * granted, provided that this notice is retained thereon and
 * on all copies.  UNM makes no representations as too the sui-
 * tability and operability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 * 
 * UNM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT-
 * NESS.  IN NO EVENT SHALL UNM BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY OTHER DAMAGES WHAT-
 * SOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PER-
 * FORMANCE OF THIS SOFTWARE.
 * 
 * No other rights, including for example, the right to redis-
 * tribute this software and its documentation or the right to
 * prepare derivative works, are granted unless specifically
 * provided in a separate license agreement.
 *---------------------------------------------------------------------
 */

#include "unmcopyright.h"        /* Copyright 1991 by UNM */


/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 >>>>
 >>>>         File Name: reader.h
 >>>>            Author: Danielle Argiro
 >>>> Date Last Updated: Tue Apr  2 15:50:00 1991
 >>>> 
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/

#ifndef _reader_h_
#define _reader_h_

#include "xvinclude.h"


/* -include_includes */
#include "ghost.h"
/* -include_includes_end */

char	**av,		/* argv and argc used by gparams */
	*program,	/* a pointer to the program name argv[0] */
	*calloc();
int	ac;

/****************************************************************
*
*                    reader Argument Structure
*
****************************************************************/

typedef struct _reader  {

/*
 *  name of program to update *.prog file for (Required string)
 */
char	*name;       	/* name of program to update *.prog file for STRING */
int	 name_flag;   	/* name of program to update *.prog file for FLAG */

/*
 *  use configuration file? (Optional logical)
 */
int	 config;      	/* use configuration file? LOGIC */
int	 config_flag;  	/* use configuration file? FLAG */

/*
 *  use lib file? (Optional logical)
 */
int	 lib;      	/* use lib file? LOGIC */
int	 lib_flag;  	/* use lib file? FLAG */

/*
 *  use man3 file? (Optional logical)
 */
int	 man3;      	/* use man3 file? LOGIC */
int	 man3_flag;  	/* use man3 file? FLAG */

/*
 *  install output? (Optional logical)
 */
int	 install;      	/* install output? LOGIC */
int	 install_flag;  	/* install output? FLAG */

/*
 *  formatting (0 = none, 1 = nroff) (Optional integer)
 */
int	 format;    	/* formatting (0 = none, 1 = nroff) INT */
int	 format_flag;	/* formatting (0 = none, 1 = nroff) FLAG */

/*
 *  use old .prog file? (Optional logical)
 */
int	 prog;      	/* use old .prog file? LOGIC */
int	 prog_flag;  	/* use old .prog file? FLAG */

/*
 *  force output? (Optional logical)
 */
int	 force;      	/* force output? LOGIC */
int	 force_flag;  	/* force output? FLAG */

}  reader_struct;

reader_struct *reader;

/* -include_additions */
/* -include_additions_end */

/* -include_macros */
/* -include_macros_end */

#endif
